## far2l 2.7.0~beta+ds

=== NetRocks/CMakeLists.txt ===
project(NetRocks)

set(SOURCES
src/Erroring.cpp
src/Globals.cpp
src/SitesConfig.cpp
src/NetRocks.cpp
src/PluginImpl.cpp
src/PluginPanelItems.cpp
src/PooledStrings.cpp
src/GetItems.cpp
src/BackgroundTasks.cpp
src/Location.cpp
src/ConnectionsPool.cpp
src/ImportFarFtpSites.cpp
src/Host/HostLocal.cpp
src/Host/HostRemote.cpp
src/Host/InitDeinitCmd.cpp
src/UI/DialogUtils.cpp
src/UI/Settings/ConfigurePlugin.cpp
src/UI/Settings/SiteConnectionEditor.cpp
src/UI/Settings/ExtraSiteSettings.cpp
src/UI/Settings/ProxySettings.cpp
src/UI/Settings/ConfigureProtocolSFTPSCP.cpp
src/UI/Settings/ConfigureProtocolFTP.cpp
src/UI/Settings/ConfigureProtocolAWS.cpp
src/UI/Settings/ConfigureProtocolSMB.cpp
src/UI/Settings/ConfigureProtocolNFS.cpp
src/UI/Settings/ConfigureProtocolWebDAV.cpp
src/UI/Settings/ConfigureProtocolSHELL.cpp
src/Protocol/SHELL/WayToShellConfig.cpp
src/UI/Activities/Confirm.cpp
src/UI/Activities/ConfirmXfer.cpp
src/UI/Activities/ConfirmOverwrite.cpp
src/UI/Activities/ConfirmChangeMode.cpp
src/UI/Activities/SimpleOperationProgress.cpp
src/UI/Activities/ComplexOperationProgress.cpp
src/UI/Activities/AbortOperationRequest.cpp
src/UI/Activities/InteractiveLogin.cpp
src/UI/Activities/ConfirmNewServerIdentity.cpp
src/UI/Activities/WhatOnError.cpp
src/UI/Activities/BackgroundTasksUI.cpp
src/Op/Utils/ProgressStateUpdate.cpp
src/Op/Utils/Enumer.cpp
src/Op/Utils/IOBuffer.cpp
src/Op/OpBase.cpp
src/Op/OpConnect.cpp
src/Op/OpCheckDirectory.cpp
src/Op/OpChangeMode.cpp
src/Op/OpEnumDirectory.cpp
src/Op/OpXfer.cpp
src/Op/OpRemove.cpp
src/Op/OpMakeDirectory.cpp
src/Op/OpExecute.cpp
src/Op/OpGetLinkTarget.cpp
src/Protocol/SplitLocationSpecification.cpp
src/Protocol/Protocol.cpp
)


set(PROTOCOL_SOURCES
src/Erroring.cpp
src/Host/HostRemoteBroker.cpp
)

add_executable (NetRocks-FILE
    ${PROTOCOL_SOURCES}
    src/Protocol/File/ProtocolFile.cpp
    src/Host/HostLocal.cpp
)

add_executable (NetRocks-SHELL
    ${PROTOCOL_SOURCES}
    src/Protocol/SHELL/ProtocolSHELL.cpp
    src/Protocol/SHELL/ProtocolSHELL_ExecCmd.cpp
    src/Protocol/SHELL/WayToShellConfig.cpp
    src/Protocol/SHELL/WayToShell.cpp
    src/Protocol/SHELL/Request.cpp
    src/Protocol/SHELL/Parse.cpp
    src/Protocol/SHELL/RemoteSh.cpp
    src/Protocol/ShellParseUtils.cpp
)

target_link_libraries(NetRocks-FILE utils)
target_include_directories(NetRocks-FILE PRIVATE src)
set_target_properties(NetRocks-FILE
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
    PREFIX ""
    SUFFIX ".broker")
target_compile_options(NetRocks-FILE PUBLIC -DNETROCKS_PROTOCOL)

target_link_libraries(NetRocks-SHELL utils)
target_include_directories(NetRocks-SHELL PRIVATE src)
set_target_properties(NetRocks-SHELL
    PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
    PREFIX ""
    SUFFIX ".broker")
target_compile_options(NetRocks-SHELL PUBLIC -DNETROCKS_PROTOCOL)

# copy resource files
set(CURRENT_TARGET "NetRocks-SHELL")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/src/Protocol/SHELL/Helpers
        "${CMAKE_CURRENT_SOURCE_DIR}/src/Protocol/SHELL/Helpers/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/src/Protocol/SHELL/Helpers
        "${INSTALL_DIR}/Plugins/NetRocks/plug/SHELL/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

if (LIBSSH_FOUND AND ((NOT DEFINED NR_SFTP) OR NR_SFTP))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_SFTP")
    add_executable (NetRocks-SFTP
        ${PROTOCOL_SOURCES}
        src/Protocol/SSH/SSHConnection.cpp
        src/Protocol/SSH/ProtocolSFTP.cpp
        src/Protocol/SSH/ProtocolSCP.cpp
        src/Protocol/FileStatsOverride.cpp
        src/Protocol/ShellParseUtils.cpp
    )
    target_link_libraries(NetRocks-SFTP utils ${LIBSSH_LIBRARIES})
    target_include_directories(NetRocks-SFTP PRIVATE src ${LIBSSH_INCLUDE_DIRS})
    # all ssh_scp_* functions are deprecated. It is recommended to use SFTP. Warnings are disabled
    target_compile_options(NetRocks-SFTP PUBLIC -Wno-deprecated-declarations)
    set_target_properties(NetRocks-SFTP
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

if (LIBSMBCLIENT_FOUND AND ((NOT DEFINED NR_SMB) OR NR_SMB))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_SMB")
    add_executable (NetRocks-SMB
        ${PROTOCOL_SOURCES}
        src/Protocol/SMB/ProtocolSMB.cpp
        src/Protocol/SMB/NMBEnum.cpp
    )
    target_link_libraries(NetRocks-SMB utils ${LIBSMBCLIENT_LIBRARIES})
    target_include_directories(NetRocks-SMB PRIVATE src ${LIBSMBCLIENT_INCLUDE_DIRS})
    target_compile_options(NetRocks-SMB PUBLIC -Wno-deprecated-declarations)
    set_target_properties(NetRocks-SMB
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

if (LIBNFS_FOUND AND ((NOT DEFINED NR_NFS) OR NR_NFS))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_NFS")
    add_executable (NetRocks-NFS
        ${PROTOCOL_SOURCES}
        src/Protocol/NFS/ProtocolNFS.cpp
    )
    target_link_libraries(NetRocks-NFS utils ${LIBNFS_LIBRARIES})
    find_package(GnuTLS)
    if (GNUTLS_FOUND)
        target_link_libraries(NetRocks-NFS ${GNUTLS_LIBRARIES})
    endif ()
    target_include_directories(NetRocks-NFS PRIVATE src ${LIBNFS_INCLUDE_DIRS})
    set_target_properties(NetRocks-NFS
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()


if (LIBNEON_FOUND AND ((NOT DEFINED NR_WEBDAV) OR NR_WEBDAV))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_WEBDAV")
    add_executable (NetRocks-WebDAV
        ${PROTOCOL_SOURCES}
        src/Protocol/WebDAV/ProtocolWebDAV.cpp
    )
    target_link_libraries(NetRocks-WebDAV utils ${LIBNEON_LIBRARIES})
    target_include_directories(NetRocks-WebDAV PRIVATE src ${LIBNEON_INCLUDE_DIRS})
    set_target_properties(NetRocks-WebDAV
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

if (AWSSDK_FOUND AND ((NOT DEFINED NR_AWS) OR NR_AWS))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_AWS")
    add_executable (NetRocks-AWS
        ${PROTOCOL_SOURCES}
        src/Protocol/AWS/AWSFile.cpp
        src/Protocol/AWS/AWSFileWriter.cpp
        src/Protocol/AWS/AWSFileReader.cpp
        src/Protocol/AWS/S3Repository.cpp
        src/Protocol/AWS/ProtocolAWS.cpp
    )
    target_include_directories(NetRocks-AWS PRIVATE src ${AWSSDK_INCLUDE_DIR})
    target_link_libraries(NetRocks-AWS utils ${AWSSDK_LINK_LIBRARIES})

    set_target_properties(NetRocks-AWS
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")
endif ()

    add_executable (NetRocks-FTP
        ${PROTOCOL_SOURCES}
        src/Protocol/FTP/ProtocolFTP.cpp
        src/Protocol/FTP/FTPConnection.cpp
        src/Protocol/FTP/FTPParseMLST.cpp
        src/Protocol/FTP/FTPParseLIST.cpp
        src/Protocol/DirectoryEnumCache.cpp
    )
    target_link_libraries(NetRocks-FTP utils)
    target_include_directories(NetRocks-FTP PRIVATE src)
if (OPENSSL_FOUND AND ((NOT DEFINED NR_OPENSSL) OR NR_OPENSSL))
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_OPENSSL")
    target_link_libraries(NetRocks-FTP ${OPENSSL_LIBRARIES})
    target_include_directories(NetRocks-FTP PRIVATE ${OPENSSL_INCLUDE_DIR})
endif ()
    set_target_properties(NetRocks-FTP
        PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".broker")


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_FAR_HAS_NAMELESS_UNIONS")

add_library (NetRocks MODULE ${SOURCES})

target_link_libraries(NetRocks utils far2l)

target_include_directories(NetRocks PRIVATE src)
target_include_directories(NetRocks PRIVATE ../WinPort)
target_include_directories(NetRocks PRIVATE ../far2l/far2sdk)

target_compile_definitions(NetRocks PRIVATE)

set_target_properties(NetRocks
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/NetRocks/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

# copy resource files
set(CURRENT_TARGET "NetRocks")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== OpenWith/CMakeLists.txt ===
project(OpenWith)

set(SOURCES
src/OpenWith.cpp
src/AppProvider.cpp
src/DummyAppProvider.cpp
src/XDGBasedAppProvider.cpp
)

if(APPLE)
    list(APPEND SOURCES src/MacOSAppProvider.mm)
endif()

add_library (${PROJECT_NAME} MODULE ${SOURCES})
target_link_libraries(${PROJECT_NAME} utils far2l)

# Frameworks for macOS
if(APPLE)
    target_link_libraries(${PROJECT_NAME}
        "-framework Cocoa"
        "-framework CoreServices"
    )
    # macOS 11
    if(${CMAKE_SYSTEM_VERSION} VERSION_GREATER_EQUAL 20.1.0)
        target_link_libraries(${PROJECT_NAME} "-framework UniformTypeIdentifiers")
    endif()
    if(${CMAKE_CXX_COMPILER} MATCHES "Clang")
        target_compile_options(${PROJECT_NAME} PRIVATE "-fobjc-arc")
    endif()
endif()

target_compile_definitions(OpenWith PRIVATE)

target_include_directories(${PROJECT_NAME} PRIVATE .)
target_include_directories(${PROJECT_NAME} PRIVATE ../far2l/far2sdk)
target_include_directories(${PROJECT_NAME} PRIVATE ../WinPort)
target_include_directories(${PROJECT_NAME} PRIVATE ../utils/include)

set_target_properties(${PROJECT_NAME} PROPERTIES
	LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/${PROJECT_NAME}/plug"
	PREFIX ""
	SUFFIX ".far-plug-wide")

set(CURRENT_TARGET "OpenWith")


file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)

setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/plug"
)

add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== SimpleIndent/CMakeLists.txt ===

project(SimpleIndent)

set(SOURCES
src/SimpleIndent.cpp 
)

add_library (SimpleIndent MODULE ${SOURCES})

target_link_libraries(SimpleIndent utils far2l)

target_compile_definitions(SimpleIndent PRIVATE -DWINPORT_DIRECT -DUNICODE -DFAR_DONT_USE_INTERNALS)

target_include_directories(SimpleIndent PRIVATE .)
target_include_directories(SimpleIndent PRIVATE ../WinPort)
target_include_directories(SimpleIndent PRIVATE ../far2l/far2sdk)

set_target_properties(SimpleIndent
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/SimpleIndent/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

=== WinPort/CMakeLists.txt ===
project(WinPort)

add_subdirectory(wineguts)

set(SOURCES
src/APIClipboard.cpp
src/APIConsole.cpp
src/APIFiles.cpp
src/APIKeyboard.cpp
src/APIOther.cpp
src/APIPrintFormat.cpp
src/APIRegistry.cpp
src/APIStringCodepages.cpp
src/APIStringMap.cpp
src/APITime.cpp
src/APIThread.cpp
src/APIMemory.cpp
src/ConsoleBuffer.cpp
src/ConsoleInput.cpp
src/ConsoleOutput.cpp
src/WinPortHandle.cpp
src/CustomPanic.cpp
src/PathHelpers.cpp
src/sudo/sudo_common.cpp
src/sudo/sudo_client.cpp
src/sudo/sudo_client_api.cpp
src/sudo/sudo_dispatcher.cpp
src/sudo/sudo_askpass.cpp
src/sudo/sudo_askpass_ipc.cpp
src/Backend/WinPortMain.cpp
src/Backend/WinPortRGB.cpp
src/Backend/SudoAskpassImpl.cpp
src/Backend/FSClipboardBackend.cpp
src/Backend/ExtClipboardBackend.cpp
src/Backend/NotifySh.cpp
src/Backend/TTY/TTYBackend.cpp
src/Backend/TTY/TTYRevive.cpp
src/Backend/TTY/TTYInput.cpp
src/Backend/TTY/TTYInputSequenceParser.cpp
src/Backend/TTY/TTYInputSequenceParserExts.cpp
src/Backend/TTY/TTYOutput.cpp
src/Backend/TTY/TTYFar2lClipboardBackend.cpp
src/Backend/TTY/OSC52ClipboardBackend.cpp
src/Backend/TTY/TTYNegotiateFar2l.cpp
src/Backend/TTY/TTYXGlue.cpp
)

if(TESTING)
    message(STATUS "Building with smoke tests support due to TESTING=${TESTING}")
    set(SOURCES
        ${SOURCES}
        src/Backend/TestController.cpp
    )
else()
    message(STATUS "Building without smoke tests support due to TESTING=${TESTING}")
endif()

add_library (WinPort STATIC ${SOURCES})

target_include_directories(WinPort PRIVATE .)
target_include_directories(WinPort PRIVATE src)
target_include_directories(WinPort PRIVATE src/Backend)

target_link_libraries(WinPort wineguts utils)

find_package(Threads REQUIRED)
if(THREADS_HAVE_PTHREAD_ARG)
    target_compile_options(WinPort PUBLIC "-pthread")
endif()
if(CMAKE_THREAD_LIBS_INIT)
    target_link_libraries(WinPort "${CMAKE_THREAD_LIBS_INIT}")
endif()
if(TESTING)
    target_compile_options(WinPort PUBLIC -DTESTING)
endif()

if(${CMAKE_SYSTEM_NAME} MATCHES "Haiku")
    target_link_libraries(WinPort root)
endif()

=== align/CMakeLists.txt ===

project(align)

set(SOURCES
src/Align.cpp 
)

add_library (align MODULE ${SOURCES})

target_link_libraries(align utils far2l)

target_compile_definitions(align PRIVATE -DWINPORT_DIRECT -DUNICODE -DFAR_DONT_USE_INTERNALS)

target_include_directories(align PRIVATE .)
target_include_directories(align PRIVATE ../far2l/far2sdk)
target_include_directories(align PRIVATE ../WinPort)

set_target_properties(align 
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/align/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

# copy resource files
set(CURRENT_TARGET "align")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== arclite/CMakeLists.txt ===

project(arclite)

set(SOURCES
    src/archive.cpp
	src/attr.cpp
	src/cmdline.cpp
	src/common.cpp
    src/headers.cpp
	src/delete.cpp
    src/extract.cpp
	src/farutils.cpp
    src/plugin.cpp
	src/msearch.cpp
	src/open.cpp
	src/options.cpp
	src/Patch7zCP.cpp
	src/pathutils.cpp
	src/rsrc.cpp
	src/sfx.cpp
	src/SimpleXML.cpp
	src/strutils.cpp
	src/sysutils.cpp
	src/ui.cpp
	src/update.cpp
	src/test.cpp
    src/MyWindows.cpp
)

#set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_COMMAND} -E time")
#set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK "${CMAKE_COMMAND} -E time")

add_library (arclite MODULE ${SOURCES})

target_compile_definitions(arclite PRIVATE -DNDEBUG)

target_link_libraries(arclite utils far2l)

target_include_directories(arclite PRIVATE 
    ../WinPort
    ../utils/include
    ../far2l/far2sdk 
    ../far2l/src/base
)

target_precompile_headers(arclite PRIVATE src/headers.hpp)
set_target_properties(arclite
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/arclite/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

# copy resource files
set(CURRENT_TARGET "arclite")
file(GLOB_RECURSE RESOURCE_FILES
		RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
		"${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
		RESOURCE_FILES
		${CMAKE_CURRENT_SOURCE_DIR}/configs
		"${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== autowrap/CMakeLists.txt ===

project(autowrap)

set(SOURCES
src/AutoWrap.cpp 
)

add_library (autowrap MODULE ${SOURCES})

target_link_libraries(autowrap utils far2l)

target_compile_definitions(autowrap PRIVATE -DWINPORT_DIRECT -DUNICODE -DFAR_DONT_USE_INTERNALS)

target_include_directories(autowrap PRIVATE .)
target_include_directories(autowrap PRIVATE ../far2l/far2sdk)
target_include_directories(autowrap PRIVATE ../WinPort)

set_target_properties(autowrap
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/autowrap/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

# copy resource files
set(CURRENT_TARGET "autowrap")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== bash-completion/CMakeLists.txt ===
install(FILES far2l DESTINATION ${CMAKE_INSTALL_DATADIR}/bash-completion/completions)

=== calc/CMakeLists.txt ===
project(calc)

set(SOURCES
    src/plugcalc/api.cpp
    src/plugcalc/api.h
    src/plugcalc/api-far2.cpp
    src/plugcalc/calc.cpp
    src/plugcalc/calc.h
    src/plugcalc/calc.rc
    src/plugcalc/config.cpp
    src/plugcalc/config.h
    src/plugcalc/messages.h
    src/plugcalc/newparse.cpp
    src/plugcalc/newparse.h
    src/plugcalc/sarg.cpp
    src/plugcalc/sarg.h
    src/plugcalc/syntax.cpp
    src/plugcalc/syntax.h
    src/plugcalc/version.h
    src/shared/mathexpression/MathExpressionBase.h
    src/shared/sgml/sgml.cpp
    src/shared/trex/trex.c
    src/shared/trex/trex.h
    src/shared/ttmath/ttmath.h
    src/shared/ttmath/ttmathbig.h
    src/shared/ttmath/ttmathint.h
    src/shared/ttmath/ttmathobjects.h
    src/shared/ttmath/ttmathparser.h
    src/shared/ttmath/ttmathtypes.h
    src/shared/ttmath/ttmathuint.h
    src/shared/ttmath/ttmathuint_noasm.h
)

#====================================================
# build
#====================================================

add_library (${PROJECT_NAME} MODULE ${SOURCES})

target_link_libraries(${PROJECT_NAME} utils far2l)

target_compile_definitions(${PROJECT_NAME} PUBLIC TTMATH_NOASM UNICODE _UNICODE)

target_include_directories(${PROJECT_NAME} PRIVATE src/shared)
target_include_directories(${PROJECT_NAME} PRIVATE ../WinPort)
target_include_directories(${PROJECT_NAME} PRIVATE ../far2l/far2sdk)

set_target_properties(${PROJECT_NAME} PROPERTIES
    # CXX_STANDARD 11
    # CXX_STANDARD_REQUIRED YES
    # CXX_EXTENSIONS NO
    LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/${PROJECT_NAME}/plug"
    PREFIX ""
    SUFFIX ".far-plug-wide")

# copy resource files
set(CURRENT_TARGET "calc")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/plug"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== colorer/CMakeLists.txt ===
project(colorer)


set(LIBCOLORER_TREE "${CMAKE_CURRENT_SOURCE_DIR}/src/Colorer-library/src")

include(src/Colorer-library/cmake/utils.cmake)

colorer_extract_version()
message(STATUS "Build Colorer: ${COLORER_VERSION}")

set(SOURCES
    src/pcolorer2/ChooseTypeMenu.h
    src/pcolorer2/FarEditor.h
    src/pcolorer2/FarEditorSet.h
    src/pcolorer2/FarHrcSettings.h
    src/pcolorer2/pcolorer.h
    src/pcolorer2/tools.h
    src/pcolorer2/ChooseTypeMenu.cpp
    src/pcolorer2/FarEditor.cpp
    src/pcolorer2/FarEditorSet.cpp
    src/pcolorer2/FarHrcSettings.cpp
    src/pcolorer2/pcolorer.cpp
    src/pcolorer2/tools.cpp
    src/pcolorer2/CerrLogger.cpp
    src/pcolorer2/CerrLogger.h
)

# set options for colorer-library
set(COLORER_USE_ICU_STRINGS OFF)
set(COLORER_USE_LIBXML ON)
set(COLORER_BUILD_HARD_WARNINGS OFF)
set(COLORER_BUILD_OLD_COMPILERS ON)

add_library(colorer MODULE ${SOURCES})

FIND_PACKAGE(LibXml2 REQUIRED)

target_include_directories(colorer
    PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/src/Colorer-library/src
    )

target_link_libraries(colorer
    utils
    colorer_lib
    far2l
    )

target_compile_definitions(colorer PUBLIC
    _UNICODE
    UNICODE
    __unix__
)


target_include_directories(colorer PRIVATE ${LIBCOLORER_TREE}/src)
target_include_directories(colorer PRIVATE src/pcolorer2)
target_include_directories(colorer PRIVATE src)
target_include_directories(colorer PRIVATE ../WinPort)
target_include_directories(colorer PRIVATE ../far2l/far2sdk)

set_target_properties(colorer
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/colorer/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

add_subdirectory("${LIBCOLORER_TREE}" "${CMAKE_BINARY_DIR}/Colorer-library/src")

set_target_properties(colorer PROPERTIES
    CXX_STANDARD 17
    CXX_STANDARD_REQUIRED YES
    CXX_EXTENSIONS YES
)

# copy resource files
set(CURRENT_TARGET "colorer")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== compare/CMakeLists.txt ===

project(editcase)

set(SOURCES
src/Compare.cpp 
)

add_library (compare MODULE ${SOURCES})

target_link_libraries(compare utils far2l)

target_compile_definitions(compare PRIVATE -DWINPORT_DIRECT -DUNICODE -DFAR_DONT_USE_INTERNALS)

target_include_directories(compare PRIVATE .)
target_include_directories(compare PRIVATE ../WinPort)
target_include_directories(compare PRIVATE ../far2l/far2sdk)

set_target_properties(compare 
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/compare/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

# copy resource files
set(CURRENT_TARGET "compare")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== drawline/CMakeLists.txt ===

project(drawline)

set(SOURCES
src/DrawLine.cpp 
)

add_library (drawline MODULE ${SOURCES})

target_link_libraries(drawline utils far2l)

target_compile_definitions(drawline PRIVATE -DWINPORT_DIRECT -DUNICODE -DFAR_DONT_USE_INTERNALS)

target_include_directories(drawline PRIVATE .)
target_include_directories(drawline PRIVATE ../WinPort)
target_include_directories(drawline PRIVATE ../far2l/far2sdk)

set_target_properties(drawline 
    PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY "${INSTALL_DIR}/Plugins/drawline/plug"
        PREFIX ""
        SUFFIX ".far-plug-wide")

# copy resource files
set(CURRENT_TARGET "drawline")
file(GLOB_RECURSE RESOURCE_FILES
        RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${CMAKE_CURRENT_SOURCE_DIR}/configs/*"
)
setup_target_auxiliary_files(${CURRENT_TARGET}
        RESOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/configs
        "${INSTALL_DIR}/Plugins/${CURRENT_TARGET}/"
)
add_dependencies(${CURRENT_TARGET} copy_aux_files_for_${CURRENT_TARGET})

=== debian/changelog ===
far2l (2.7.0~beta+ds-1) unstable; urgency=medium

  * New upstream release.
  * Tighten far2l dependency on far2l-data.
  * Update debian/copyright (using the script and manually).
  * Drop changelog.md-Set-release-date-for-v2.6.5.patch, included in the
    new release.
  * Register far2ledit as an alternative for /usr/bin/editor.
    - Add a patch to run in editor mode when called this way.
  * Fix Lintian warnings about executable non-scripts, .gitignore and
    empty directories.
  * Drop ‘Rules-Requires-Root: no’, it became default in dpkg 1.22.13.

 -- Dmitry Shachnev <mitya57@debian.org>  Tue, 28 Oct 2025 18:00:22 +0300

far2l (2.6.5~beta+ds-4) unstable; urgency=medium

  * d/rules: ignore minimal cmake version. (Closes: #1112880)

 -- Alex Myczko <tar@debian.org>  Mon, 29 Sep 2025 09:43:56 +0200

=== debian/control ===
Source: far2l
Section: utils
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Uploaders: Dmitry Shachnev <mitya57@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libsmbclient-dev,
 libneon27-dev,
 libnfs-dev,
 libssh-dev,
 libxi-dev,
 libuchardet-dev,
 libarchive-dev,
 libssl-dev,
 libwxgtk3.2-dev,
 libx11-dev,
 libpython3-dev,
 python3-cffi,
 python3-markdown,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/far2l
Vcs-Git: https://salsa.debian.org/debian/far2l.git
Homepage: https://github.com/elfmz/far2l

Package: far2l
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, far2l-data (= ${source:Version})
Recommends: ${shlibs:Recommends}
Suggests: chafa, htop, far2l-wx
Breaks: far2l-wx (<< 2.6.5~beta+ds-1~)
Replaces: far2l-wx (<< 2.6.5~beta+ds-1~)
Description: Linux port of FAR v2
 This is a clone of FAR manager for Windows, similar, but more
 powerful than Norton Commander/Midnight Commander.
 .
 Plug-ins that are currently working:
  - NetRocks (SFTP/SCP/FTP/FTPS/SMB/NFS/WebDAV)
  - colorer
  - multiarc
  - tmppanel
  - align
  - autowrap
  - drawline
  - editcase
  - SimpleIndent

Package: far2l-wx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, far2l (= ${binary:Version})
Breaks: far2l (<< 2.6.5~beta+ds-1~)
Replaces: far2l (<< 2.6.5~beta+ds-1~)
Description: Linux port of FAR v2 - WX GTK UI
 This is a clone of FAR manager for Windows, similar, but more
 powerful than Norton Commander/Midnight Commander.
 .
 Plug-ins that are currently working:
  - NetRocks (SFTP/SCP/FTP/FTPS/SMB/NFS/WebDAV)
  - colorer
  - multiarc
  - tmppanel
  - align
  - autowrap
  - drawline
  - editcase
  - SimpleIndent
  - Python
 .
 This package contains a WX GTK user interface for far2l. It will be used
 automatically when running far2l in a graphical desktop environment.

Package: far2l-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Linux port of FAR v2, data files
 This is a clone of FAR manager for Windows, similar, but more
 powerful than Norton Commander/Midnight Commander.
 .
 Plug-ins that are currently working:
  - NetRocks (SFTP/SCP/FTP/FTPS/SMB/NFS/WebDAV)
  - colorer
  - multiarc
  - tmppanel
  - align
  - autowrap
  - drawline
  - editcase
  - SimpleIndent
 .
 This package contains the data files needed to run far2l.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -Bdebian/build-far2l -- \
		-DUNRAR=NO -DPYTHON=yes -DUSEWX=yes -DTTYX=yes -DTTYXI=yes -DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_auto_build:
	dh_auto_build -Bdebian/build-far2l

override_dh_auto_clean:
	dh_auto_clean -Bdebian/build-far2l

override_dh_auto_install:
	dh_auto_install -Bdebian/build-far2l      \
		--destdir=debian/install-far2l     -X.la -X.pyc -X.pyo -X__pycache__

override_dh_install:
	chmod -x debian/install-far2l/usr/share/far2l/Plugins/NetRocks/plug/SHELL/remote.sh
	chmod -x debian/install-far2l/usr/share/far2l/far2l-cd.sh
	rm debian/install-far2l/usr/share/far2l/Plugins/python/plugins/.gitignore
	find debian/install-far2l -type d -empty -delete
	# no -pfar2l becouse destination directory by default far2l
	# and we need also generate far2l-data
	dh_install              --sourcedir=debian/install-far2l
	rm -rf debian/far2l/usr/lib/far2l/Plugins/python/plug/python

override_dh_installman:
	dh_installman --sourcedir=debian/install-far2l

override_dh_shlibdeps:
	# Move libraries needed by brokers to Recommends. Far2l starts fine without them,
	# they only provide extended functionality.
	dh_shlibdeps -X.broker -- -dRecommends $$(find debian/far2l -name "*.broker") -dDepends

ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
override_dh_link:
	dh_link -pfar2l \
		usr/share/man/man1/far2l.1.gz usr/share/man/man1/far2ledit.1.gz \
		usr/share/man/ru/man1/far2l.1.gz usr/share/man/ru/man1/far2ledit.1.gz
endif

###-DCMAKE_USE_OPENSSL=OFF
###-DOPENSSL_ROOT_DIR=/dev/null
